<template>
    <div class="edit-popup">
        <popup ref="popupRef" :title="popupTitle" :async="true" width="550px" @confirm="handleSubmit"
            @close="handleClose">
            <el-form ref="formRef" :model="formData" label-width="100px" :rules="formRules">
                <el-form-item label="所属目录" prop="directory_id">
                    <el-select v-model="formData.directory_id" remote filterable :remote-method="queryCostProject"
                        :loading="loading" class="flex-1">
                        <el-option v-for="(item, index) in optionsData.projectList.lists" :key="index"
                            :label="item.name" :value="item.id" />
                    </el-select>
                </el-form-item>
                <el-form-item label="子目录名称" prop="name">
                    <el-input v-model="formData.name" clearable placeholder="请输入子目录名称" />
                </el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="consultSubdirectoryEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiConsultSubdirectoryAdd, apiConsultSubdirectoryEdit, apiConsultSubdirectoryDetail } from '@/api/consult_subdirectory'
import { apiConsultDirectoryLists } from '@/api/consult_directory'
import { useDictOptions } from "@/hooks/useDictOptions"
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')


// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑项目咨询--全过程咨询子目录' : '新增项目咨询--全过程咨询子目录'
})

// 表单数据
const formData = reactive({
    id: '',
    directory_id: '',
    name: '',
})


// 表单验证
const formRules = reactive<any>({
    directory_id: [{
        required: true,
        message: '请输入所属目录',
        trigger: ['blur']
    }],
    name: [{
        required: true,
        message: '请输入子目录名称',
        trigger: ['blur']
    }]
})

const { optionsData } = useDictOptions<{
    projectList: any[]
}>({
    projectList: {
        api: apiConsultDirectoryLists,
    }
})


const loading = ref(false)

const queryCostProject = async (query: string) => {
    loading.value = true
    const projectList = await apiConsultDirectoryLists()
    optionsData.projectList = projectList

    console.log(optionsData, 'optionsData')
    loading.value = false
}


// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }


}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiConsultSubdirectoryDetail({
        id: row.id
    })
    setFormData(data)
}


// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData, }
    mode.value == 'edit'
        ? await apiConsultSubdirectoryEdit(data)
        : await apiConsultSubdirectoryAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}



defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
